<?php
/**
 *
 * This software is a derived product, based on:
 * @name     	PortaMX-SubForums
 * @copyright	PortaMx Corp. http://portamx.com (SMF Version)
 *
 * and is rewritten for ElkArte:
 * @author	ahrasis (Hj Ahmad Rasyid Hj Ismail)
 * @email	ahrasis@gmail.com
 * @link	http://sahabat.ahrasis.com
 * @license	BSD http://opensource.org/licenses/BSD-3-Clause
 * @addon	MultiTenancy
 *
 **/

global $db_prefix, $user_info, $boardurl, $txt;

// Load the SSI.php
if (file_exists(dirname(__FILE__) . '/SSI.php') && !defined('ELK'))
{
	function _write($string) { echo $string; }

	require_once(dirname(__FILE__) . '/SSI.php');

	// on manual installation you have to logged in
	if(!$user_info['is_admin']) 
	{
		if($user_info['is_guest']) 
		{
			echo '<b>', $txt['admin_login'],':</b><br />';
			ssi_login($boardurl.'/Tenancy.dbinstall.php');
			die();
		}
		else 
		{
			loadLanguage('Errors');
			fatal_error($txt['cannot_admin_forum']);
		}
	}
}
// no SSI.php and no ELK?
elseif (!defined('ELK'))
	die('<b>Error:</b> SSI.php not found. Please verify you put this in the same place as ElkArte\'s index.php.');
else
{
	function _write($string) { return; };
}

// split of dbname (mostly for SSI)
$pref = explode('.', $db_prefix);
if(!empty($pref[1]))
	$pref = $pref[1];
else
	$pref = $db_prefix;

// Load the ELK DB Functions
if (ELK == 'SSI') {
	db_extend('packages');
	db_extend('extra');
}

$db = database();
$dbtbl = db_table();

/********************
* Define the tables *                      
*********************/ 
$tabledate = array(
	'subforums',
);

// loop through each table
foreach($tabledate as $tblname)
{
	// check if the table exist
	_write('Processing Table "'. $pref . $tblname .'".<br />');
	$tablelist = $db->db_list_table(false, $pref. $tblname);
	if(!empty($tablelist) && in_array($pref . $tblname, $tablelist))
	{
		// drop table
		$dbtbl->db_drop_table('{db_prefix}'. $tblname);
		_write('.. Table "'. $pref . $tblname .'" successful dropped.<br /><br />');
	}
	else
		_write('.. Table "'. $pref . $tblname .'" not exist.<br /></br />');
}

// done
_write('dbremove done.');
?>