<?php
/**
 *
 * This software is a derived product, based on:
 * @name     	PortaMX-SubForums
 * @copyright	PortaMx Corp. http://portamx.com (SMF Version)
 *
 * and is rewritten for ElkArte:
 * @author	ahrasis (Hj Ahmad Rasyid Hj Ismail)
 * @email	ahrasis@gmail.com
 * @link	http://sahabat.ahrasis.com
 * @license	BSD http://opensource.org/licenses/BSD-3-Clause
 * @addon	MultiTenancy
 *
 **/

// If we have found SSI.php and we are outside of ELK, then we are running standalone.
if (file_exists(dirname(__FILE__) . '/SSI.php') && !defined('ELK'))
	require_once(dirname(__FILE__) . '/SSI.php');

// If we are outside ELK and can't find SSI.php, then throw an error
elseif (!defined('ELK'))
	die('<b>Error:</b> Cannot install - please verify you put this file in the same place as Elkarte\'s SSI.php.');
	
// Define the hooks
$hook_functions = array(
	'integrate_pre_include' => 'SOURCEDIR/addons/tenancy/Tenancy.subs.php',
	'integrate_pre_log_stats' => 'Tenancy::PreLogStats|SOURCEDIR/addons/tenancy/Tenancy.subs.php',
	'integrate_init_theme' => 'Tenancy::InitTheme|SOURCEDIR/addons/tenancy/Tenancy.subs.php',
	'integrate_pre_load' => 'Tenancy::PreLoad|SOURCEDIR/addons/tenancy/Tenancy.subs.php',
	'integrate_load_theme' => 'Tenancy::LoadTheme|SOURCEDIR/addons/tenancy/Tenancy.subs.php',
	'pre_css_output' => 'Tenancy::ChangeUrlInHive|SOURCEDIR/addons/tenancy/Tenancy.subs.php',
	'integrate_buffer' => 'Tenancy::BufferUrl|SOURCEDIR/addons/tenancy/Tenancy.subs.php',
	'integrate_admin_areas' => 'Tenancy::AdminMenu|SOURCEDIR/addons/tenancy/Tenancy.subs.php',
	'integrate_register' => 'Tenancy::Register|SOURCEDIR/addons/tenancy/Tenancy.subs.php',
);

/*
// Unused hooks
	'integrate_pre_log_stats' => 'Tenancy::PreLogStats|SOURCEDIR/addons/tenancy/Tenancy.subs.php',
	'integrate_init_theme' => 'Tenancy::InitTheme|SOURCEDIR/addons/tenancy/Tenancy.subs.php',
	'post_css_combine' => 'Tenancy::MoveHiveFiles|SOURCEDIR/addons/tenancy/Tenancy.subs.php',
*/

// Adding or removing them?
if (!empty($context['uninstalling']))
	$call = 'remove_integration_function';
else
	$call = 'add_integration_function';

// Do the deed
foreach ($hook_functions as $hook => $function)
	$call($hook, $function);

if (ELK == 'SSI')
   echo 'Congratulations! You have successfully installed this mod!';
   
?>