<?php
/**
 *
 * This software is a derived product, based on:
 * @name     	PortaMX-SubForums
 * @copyright	PortaMx Corp. http://portamx.com (SMF Version)
 *
 * and is rewritten for ElkArte:
 * @author	ahrasis (Hj Ahmad Rasyid Hj Ismail)
 * @email	ahrasis@gmail.com
 * @link	http://sahabat.ahrasis.com
 * @license	BSD http://opensource.org/licenses/BSD-3-Clause
 * @addon	MultiTenancy
 *
 **/ 

function template_main()
{
	global $context, $settings, $modSettings, $scripturl, $base_boardurl, $mbname, $txt;

	echo '
	<div style="overflow:hidden;">
	<div class="cat_bar">
		<h3 class="catbg">'. $txt['tenancy_admin_title'] .'</h3>
	</div>
	<p class="windowbg description">'. $txt['tenancy_admin_description'] .'</p>

	<div class="windowbg">
		<form id="MultiTenancyID" accept-charset="UTF-8" name="Subforums" action="' . $scripturl . '?action=admin;area=multitenancy;'. $context['session_var'] .'=' .$context['session_id'] .'" method="post" style="margin:0; padding:0;">
			<input type="hidden" name="sc" value="', $context['session_id'], '" />
			<input id="MultiTenancyAction" type="hidden" name="" value="" />

			<table class="table_grid" width="100%" cellspacing="0" cellpadding="0" style="margin-bottom:0;">
				<tr class="catbg">';

	if(empty($context['subforums']['action']))
		echo '
					<th class="first_th" width="22%" align="left">&nbsp;'. $txt['tenancy_admin_host_name'] .'</th>
					<th width="28%" align="left">&nbsp;'. $txt['tenancy_admin_cats'] .'</th>
					<th width="28%" align="left">&nbsp;'. $txt['tenancy_admin_theme_access'] .'</th>
					<th class="last_th" width="22%" align="left">&nbsp;'. $txt['tenancy_admin_theme'] .'</th>
				</tr>';
	else
		echo '
					<th class="first_th" width="24%" align="left">&nbsp;'. $txt['tenancy_admin_host'] .'</th>
					<th width="28%" align="left">&nbsp;'. $txt['tenancy_admin_cats'] .'</th>
					<th width="24%" align="left">&nbsp;'. $txt['tenancy_admin_access'] .'</th>
					<th class="last_th" width="24%" align="left">&nbsp;'. $txt['tenancy_admin_theme'] .'</th>
				</tr>';

	if(empty($context['subforums']['action']))
	{
		$urlparts = parse_url($scripturl);
		$baseurl = parse_url($base_boardurl);
		foreach($context['subforums']['data'] as $part)
		{
			echo '
				<tr id="tr.'. $part['host'] .'">
					<td valign="top" class="smalltext" style="padding:3px 8px;">
						<a href="javascript:void(\'\')"  onclick="SubforumsSwitchto(\''. $part['host'] .'\')"><b>'. $part['host'] .'</b></a>';

			if($_SERVER['SERVER_NAME'] == $part['host'])
				echo '
						&nbsp;<img src="', $settings['images_url'], '/icons/field_valid.png' .'" alt="**" />';

			echo '
						<br />'. (empty($part['name']) ? $mbname : $part['name']) .'
						<hr />
						'. sprintf($txt['tenancy_admin_info'], $part['topics'], $part['posts']) .'
					</td>
					<td valign="top" class="smalltext" style="padding:3px 8px;">';

			$islast = count($part['cats']) -1;
			foreach($part['cats'] as $catid)
			{
				echo str_replace(' ', '&nbsp;', $context['subforums']['Forum_Cats'][$catid]) . (!empty($islast) ? ', ' : '');
				$islast--;
			}

			echo '
					</td>
					<td valign="top" class="smalltext" style="padding:3px 8px;">';

			if(count($part['groups']) > 0)
			{
				$islast = count($part['groups']) -1;
				foreach($part['groups'] as $grpID)
				{
					echo str_replace(' ', '&nbsp;', $context['subforums']['Forum_Groups'][$grpID]) . (!empty($islast) ? ', ' : '');
					$islast--;
				}
			}
			else
				echo $txt['tenancy_admin_nogroups'];

			echo '
					</td>
					<td valign="top" class="smalltext" align="left" style="padding:3px 8px;border-right:0;">
						<div id="div.'. $part['host'] .'">
							'. (!empty($context['subforums']['Forum_Themes'][$part['theme']]) ? $context['subforums']['Forum_Themes'][$part['theme']] : $txt['tenancy_admin_themedefault']) .'<br />
							'. (!empty($context['subforums']['languages'][$part['language']]) ? $context['subforums']['languages'][$part['language']]['name'] : $txt['tenancy_admin_themedefault']) .'
							<hr />
						</div>
						<div id="pos.'. $part['host'] .'" style="position:relative; top:0; text-align:right;">';

			if($_SERVER['SERVER_NAME'] != $part['host'])
				echo '
							<input class="button_submit smalltext" type="button" value="'. $txt['tenancy_admin_delete'] .'" name="" onclick="SubforumsSubmit(\'sf_delete\', \''. $part['id'] .'\', \''. sprintf($txt['tenancy_admin_delete_msg'], $part['host']) .'\')" />';

			echo '
							&nbsp;<input class="button_submit smalltext" type="button" value="'. $txt['tenancy_admin_edit'] .'" name="" onclick="SubforumsSubmit(\'sf_edit\', \''. $part['id'] .'\')" />
						</div>
					</td>
				</tr>';
		}

		echo '
				<tr>
					<td colspan="2" class="smalltext" style="padding:3px 8px;">
						<a href="javascript:void(\'\')"  onclick="SubforumsSwitchto(\''. $baseurl['host'] .'\')"><b>[ '. $baseurl['host'] .' ]</b></a>';

		if($_SERVER['SERVER_NAME'] == $baseurl['host'])
			echo '
						<img src="', $settings['images_url'], '/icons/field_valid.png' .'" alt="**" />';

		echo '
						<br />'. $mbname .'
					</td>
					<td valign="top" class="smalltext" style="padding:3px 8px;">
						<input type="hidden" name="subforums_adminonly" value="0" />
						<span style="vertical-align:top;">'. $txt['tenancy_admin_onlyadmin'] .'</span>
						<input style="float:right;" class="input_check" type="checkbox" name="subforums_adminonly" value="1"'. (!empty($modSettings['subforums_adminonly']) ? ' checked="checked"' : '') .' onchange="SubforumsSubmit(\'sf_save\', \'main\')" />
						<br style="clear:both;" />
						<input type="hidden" name="subforums_xmlrss" value="0" />
						<span style="vertical-align:top;">'. $txt['tenancy_admin_xmlrss'] .'</span>
						<input style="float:right;" class="input_check" type="checkbox" name="subforums_xmlrss" value="1"'. (!empty($modSettings['subforums_xmlrss']) ? ' checked="checked"' : '') .' onchange="SubforumsSubmit(\'sf_save\', \'main\')" />
					</td>
					<td valign="top" align="right" style="padding:6px 8px;border-right:0;">
						<input class="button_submit smalltext" type="button" value="'. $txt['tenancy_admin_add'] .'" name="" onclick="SubforumsSubmit(\'sf_add\', 0)" />
					</td>
				</tr>';
	}

	elseif($context['subforums']['action'] == 'edit')
	{
			echo '
				<tr>
					<td valign="top" align="left" style="padding:8px 8px 3px 8px;">
						<div style="height:77px">
							<input type="text" name="SF_host" value="'. $context['subforums']['data']['host'] .'" class="input_text" style="width:97%;" />
							<br />
							<span class="smalltext">'. $txt['tenancy_admin_host_help'] .'</span>
						</div>
					</td>
					<td valign="top" align="left" rowspan="2" style="padding:8px 8px 3px 8px;">
						<select name="SF_category[]" multiple="multiple" size="9" style="width:100%;height:10em;max-height:10em;" class="smalltext">';

			foreach($context['subforums']['Forum_Cats'] as $catID => $catName)
				echo'
							<option value="'. $catID .'"'. (in_array($catID, $context['subforums']['data']['cats']) ? 'selected="selected"' : ''). '>'. $catName .'</option>';

			echo '
						</select>
						<br /><span class="smalltext">'. $txt['tenancy_admin_select_help'] .'</span>
					</td>
					<td valign="top" align="left" rowspan="2" style="padding:8px 8px 3px 8px;">
						<select name="SF_groups[]" size="9" multiple="multiple" style="width:100%;height:10em;max-height:10em;" class="smalltext">';

			foreach($context['subforums']['Forum_Groups'] as $grpID => $grpName)
				echo'
							<option value="'. $grpID .'"'. (!empty($context['subforums']['data']['groups']) && in_array($grpID, $context['subforums']['data']['groups']) ? 'selected="selected"' : ''). '>'. $grpName .'</option>';

			echo '
						</select>
						<br /><span class="smalltext">'. $txt['tenancy_admin_access_help'] .'</span>
					</td>
					<td valign="top" align="left" style="padding:8px 8px 3px 8px;border-right:0;">
						<div style="min-height:25px;">
						'. $txt['tenancy_admin_themes'] .'<select name="SF_idtheme" size="1" style="float:right;width:50%;" class="smalltext">
							<option value="0"'. (empty($context['subforums']['data']['theme']) ? 'selected="selected"' : '') .'>'. $txt['tenancy_admin_themedefault'] .'</option>';

			foreach($context['subforums']['Forum_Themes'] as $thID => $thName)
				echo'
							<option value="'. $thID .'"'. ($thID == $context['subforums']['data']['theme'] ? 'selected="selected"' : ''). '>'. $thName .'</option>';

			echo '
						</select>
						</div>
						<div style="min-height:20px;">
						'. $txt['tenancy_admin_languages'] .'<select name="SF_language" size="1" style="float:right;width:50%;" class="smalltext">
							<option value=""'. (empty($context['subforums']['data']['language']) ? 'selected="selected"' : '') .'>'. $txt['tenancy_admin_themedefault'] .'</option>';

			foreach($context['subforums']['languages'] as $lang => $langData)
				echo'
							<option value="'. $lang .'"'. ($lang == $context['subforums']['data']['language'] ? 'selected="selected"' : ''). '>'. $langData['name'] .'</option>';

			echo '
						</select>
						</div>
						<span class="smalltext">'. $txt['tenancy_admin_theme_help'] .'</span>
					</td>
				</tr>

				<tr>
					<td valign="top">
						<table class="table_grid" width="100%" cellspacing="0" cellpadding="0" style="margin-bottom:4px;">
							<tr class="catbg">
								<th class="first_th" scope="col" align="left">&nbsp;'. $txt['tenancy_admin_name'] .'</th>
								<th class="last_th" width="2%" scope="col" align="left"></th>
							</tr>
						</table>
						<div  style="padding:0px 5px 0 5px;">
							<input type="text" name="SF_name" value="'. $context['subforums']['data']['name'] .'" class="input_text" style="width:97%;" />
							<br /><span class="smalltext">'. $txt['tenancy_admin_name_help'] .'</span>
						</div>
					</td>
					<td valign="top" style="padding:6px 8px; border-right:0;">
						<div style="min-height:90px;">
							<div style="padding-bottom:5px;">'. $txt['tenancy_admin_reg_memgroup'] .'</div>
							<select name="SF_reggroup" size="1" style="float:right;width:70%;" class="smalltext">';

			foreach($context['subforums']['Forum_Groups'] as $grpID => $grpName)
			{
				if($grpID == -1)
					$grpName = $txt['tenancy_admin_themedefault'];
				echo'
								<option value="'. $grpID .'"'. (!empty($context['subforums']['data']['reg_group']) && $grpID == $context['subforums']['data']['reg_group'] ? 'selected="selected"' : ''). '>'. $grpName .'</option>';
			}

			echo '
							</select>
						</div>
						<div style="clear:both;text-align:right;">
							<input class="button_submit smalltext" type="button" value="'. $txt['modify_cancel'] .'" name="" onclick="SubforumsSubmit(\'sf_cancel\', \'0\')" />&nbsp;
							<input class="button_submit smalltext" type="button" value="'. $txt['save'] .'" name="" onclick="SubforumsSubmit(\'sf_save\', \''. $context['subforums']['data']['id'] .'\')" />
						</div>
					</td>
				</tr>';
	}

	echo '
			</table>
			<span class="botslice"><span></span></span>
		</form>
	</div>
	</div>

	<script language="JavaScript" type="text/javascript"><!-- // --><![CDATA[
		function SubforumsSwitchto(host)
		{
			var oldhost = window.location.hostname;
			window.location.href = window.location.href.replace(oldhost, host);
		}
		function SubforumsSubmit(sfName, sfVal, sfMsg)
		{
			if(sfMsg)
			{
				if(!confirm(sfMsg) == true)
				return;
			}
			document.getElementById("MultiTenancyAction").name = sfName;
			document.getElementById("MultiTenancyAction").value = sfVal;
			document.getElementById("MultiTenancyID").submit();
		}';

	if(empty($context['subforums']['action']))
	{
		echo '
		function MultiTenancySetPost(elm)
		{
			var divpos = document.getElementById("tr." +elm).offsetHeight - document.getElementById("div." +elm).offsetHeight;
			document.getElementById("pos." +elm).style.top = (divpos - 37) +"px";
		}';

		foreach($context['subforums']['data'] as $part)
			echo '
		MultiTenancySetPost("'. $part['host'] .'");';
	}

	echo '
	// ]]></script>';
}
?>